## libvigraimpex 1.7.1+dfsg1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

##################################################
#
#     basic initializations
#
##################################################

PROJECT(vigra)

# read the current version from configVersion.hxx
file(READ ${vigra_SOURCE_DIR}/include/vigra/configVersion.hxx VIGRA_VERSION_FILE)
string(REGEX MATCH "VIGRA_VERSION_MAJOR[ \t\n]+[^ \t\n]+" VIGRA_VERSION_MAJOR ${VIGRA_VERSION_FILE})
string(REGEX REPLACE "VIGRA_VERSION_MAJOR[ \t\n]" "" VIGRA_VERSION_MAJOR ${VIGRA_VERSION_MAJOR})
string(REGEX MATCH "VIGRA_VERSION_MINOR[ \t\n]+[^ \t\n]+" VIGRA_VERSION_MINOR ${VIGRA_VERSION_FILE})
string(REGEX REPLACE "VIGRA_VERSION_MINOR[ \t\n]" "" VIGRA_VERSION_MINOR ${VIGRA_VERSION_MINOR})
string(REGEX MATCH "VIGRA_VERSION_PATCH[ \t\n]+[^ \t\n]+" VIGRA_VERSION_PATCH ${VIGRA_VERSION_FILE})
string(REGEX REPLACE "VIGRA_VERSION_PATCH[ \t\n]" "" VIGRA_VERSION_PATCH ${VIGRA_VERSION_PATCH})

SET(vigra_version_short ${VIGRA_VERSION_MAJOR}.${VIGRA_VERSION_MINOR})
SET(vigra_version ${VIGRA_VERSION_MAJOR}.${VIGRA_VERSION_MINOR}.${VIGRA_VERSION_PATCH})
message(STATUS "Configuring VIGRA version ${vigra_version}")

SET(CMAKE_MODULE_PATH  ${CMAKE_MODULE_PATH}  ${vigra_SOURCE_DIR}/config)

include(VigraSetDefaults)

INCLUDE_DIRECTORIES(${vigra_SOURCE_DIR}/include)

IF (MSVC)
    ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE -D_SECURE_SCL=0 -D_SCL_SECURE_NO_DEPRECATE)
ENDIF ()

##################################################
#
#     search for dependencies
#
##################################################

INCLUDE(VigraFindPackage)
VIGRA_FIND_PACKAGE(TIFF NAMES libtiff)
VIGRA_FIND_PACKAGE(JPEG NAMES libjpeg)
VIGRA_FIND_PACKAGE(PNG)
VIGRA_FIND_PACKAGE(FFTW3 NAMES libfftw3-3)
IF(WITH_HDF5)
    VIGRA_FIND_PACKAGE(HDF5)
ENDIF()

FIND_PACKAGE(Doxygen)
FIND_PACKAGE(PythonInterp)

IF(WITH_VIGRANUMPY)
    FIND_PACKAGE( VIGRANUMPY_DEPENDENCIES )
ENDIF()

IF(WITH_VALGRIND)
    FIND_PROGRAM(VALGRIND_EXECUTABLE valgrind)
ENDIF()

##################################################
#
#     setup testing environment
#
##################################################

ADD_CUSTOM_TARGET(check)
ADD_CUSTOM_TARGET(ctest COMMAND ${CMAKE_CTEST_COMMAND})

ADD_CUSTOM_TARGET(check_cpp)
ADD_DEPENDENCIES(check check_cpp)


OPTION(CREATE_CTEST_TARGETS "Create special targets for CTest" OFF)
IF(CREATE_CTEST_TARGETS)
  INCLUDE(CTest)
ENDIF()

IF(WITH_VIGRANUMPY)
    ADD_CUSTOM_TARGET(check_python)
    ADD_DEPENDENCIES(check check_python)
ENDIF()

ENABLE_TESTING()

##################################################
#
#     setup documentation generator
#
##################################################

ADD_CUSTOM_TARGET(doc)

##################################################
#
#     setup private experimentation target
#
##################################################

ADD_CUSTOM_TARGET(experiments)

##################################################
#
#     subdirectories
#
##################################################

INCLUDE_DIRECTORIES(${PROJECT_BINARY_DIR}/include)
ADD_SUBDIRECTORY(src)
ADD_SUBDIRECTORY(test)
ADD_SUBDIRECTORY(docsrc)

IF(WITH_VIGRANUMPY)
    ADD_SUBDIRECTORY(vigranumpy)
ENDIF()

IF(EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/private/CMakeLists.txt)
	ADD_SUBDIRECTORY(private EXCLUDE_FROM_ALL)
ENDIF()


##################################################
#
#     global installation commands
#
##################################################

INSTALL(DIRECTORY ${PROJECT_SOURCE_DIR}/include/vigra
		DESTINATION include)

##################################################
#
#     enable CPack package generation
#
##################################################
INCLUDE(CPackConfig)

##################################################
#
#  enable other non-CMake projects to find Vigra
#
##################################################

IF(NOT WIN32)
# vigra-config script for (non-CMake-based) third party packages
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/vigra-config.in
		${PROJECT_BINARY_DIR}/bin/vigra-config
		@ONLY IMMEDIATE)
INSTALL(FILES ${PROJECT_BINARY_DIR}/bin/vigra-config
		DESTINATION bin
		PERMISSIONS
			OWNER_READ OWNER_WRITE OWNER_EXECUTE
			GROUP_READ GROUP_EXECUTE
			WORLD_READ WORLD_EXECUTE)
ENDIF(NOT WIN32)

##################################################
#
#     enable other CMake projects to find Vigra
#
##################################################

# config file for CMake FIND_PACKAGE command (for using the build tree)
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/VigraConfigBuild.cmake.in
		${PROJECT_BINARY_DIR}/VigraConfig.cmake
		@ONLY IMMEDIATE)
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/VigraConfigVersion.cmake.in
		${PROJECT_BINARY_DIR}/VigraConfigVersion.cmake
		@ONLY IMMEDIATE)

# config file for CMake FIND_PACKAGE command
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/VigraConfig.cmake.in
		${PROJECT_BINARY_DIR}/lib/vigra/CMake/VigraConfig.cmake
		@ONLY IMMEDIATE)
CONFIGURE_FILE(${PROJECT_SOURCE_DIR}/config/VigraConfigVersion.cmake.in
		${PROJECT_BINARY_DIR}/lib/vigra/CMake/VigraConfigVersion.cmake
		@ONLY IMMEDIATE)

# export targets:
INSTALL(EXPORT vigra-targets
		DESTINATION lib${LIBDIR_SUFFIX}/vigra)
INSTALL(FILES ${PROJECT_BINARY_DIR}/lib/vigra/CMake/VigraConfig.cmake
			${PROJECT_BINARY_DIR}/lib/vigra/CMake/VigraConfigVersion.cmake
		DESTINATION lib${LIBDIR_SUFFIX}/vigra)
EXPORT(TARGETS vigraimpex FILE vigra-targets.cmake)

##################################################
#
#     status output
#
##################################################

MESSAGE( STATUS "---------------------------------------------------------" )
MESSAGE( STATUS "VIGRA configuration information:" )
MESSAGE( STATUS "---------------------------------------------------------" )

IF(TIFF_FOUND)
    MESSAGE( STATUS "  Using TIFF libraries: ${TIFF_LIBRARIES}" )
ELSE()
    MESSAGE( STATUS "  TIFF libraries not found (TIFF support disabled)" )
ENDIF()

IF(JPEG_FOUND)
    MESSAGE( STATUS "  Using JPEG libraries: ${JPEG_LIBRARIES}" )
ELSE()
    MESSAGE( STATUS "  JPEG libraries not found (JPEG support disabled)" )
ENDIF()

IF(PNG_FOUND)
    MESSAGE( STATUS "  Using PNG  libraries: ${PNG_LIBRARIES}" )
ELSE()
    MESSAGE( STATUS "  PNG libraries not found (PNG support disabled)" )
ENDIF()

IF(FFTW3_FOUND)
    MESSAGE( STATUS "  Using FFTW libraries: ${FFTW3_LIBRARIES}" )
ELSE()
    MESSAGE( STATUS "  FFTW libraries not found (FFTW support disabled)" )
ENDIF()

IF(HDF5_FOUND)
    MESSAGE( STATUS "  Using HDF5 libraries: ${HDF5_LIBRARIES}" )
ELSE()
    MESSAGE( STATUS "  HDF5 libraries not found (HDF5 support disabled)" )
ENDIF()

IF(WITH_VIGRANUMPY)
    IF(VIGRANUMPY_DEPENDENCIES_FOUND)
        MESSAGE( STATUS "  Using Python libraries: ${VIGRANUMPY_LIBRARIES}" )
    ELSE()
        MESSAGE( STATUS "  Vigranumpy dependencies not found (vigranumpy disabled)" )
    ENDIF()
ENDIF()

MESSAGE( STATUS "---------------------------------------------------------" )
MESSAGE( STATUS "  binaries will be generated in: ${CMAKE_CURRENT_BINARY_DIR}")
IF(DOXYGEN_FOUND AND PYTHONINTERP_FOUND)
	MESSAGE( STATUS "  manuals will be generated in: ${DOCDIR}")
ENDIF()
	MESSAGE( STATUS "---------------------------------------------------------" )

MESSAGE( STATUS "  includes will be installed at: ${CMAKE_INSTALL_PREFIX}/include")
MESSAGE( STATUS "  libraries will be installed at: ${CMAKE_INSTALL_PREFIX}/lib${LIBDIR_SUFFIX}")

IF (MSVC)
  MESSAGE( STATUS "  binaries and DLLs will be installed at: ${CMAKE_INSTALL_PREFIX}/bin")
else()
  MESSAGE( STATUS "  binaries will be installed at: ${CMAKE_INSTALL_PREFIX}/bin")
endif()

IF(DOXYGEN_FOUND AND PYTHONINTERP_FOUND)
  MESSAGE( STATUS "  vigra manuals will be installed at: "
    "${CMAKE_INSTALL_PREFIX}/${DOCINSTALL}/vigra/index.html")
ELSE()
  MESSAGE( STATUS "  vigra manuals cannot be generated (Doxygen or Python not found)")
ENDIF()

IF(WITH_VIGRANUMPY AND VIGRANUMPY_DEPENDENCIES_FOUND)
  MESSAGE( STATUS "  vigranumpy will be installed at ${CMAKE_INSTALL_PREFIX}/${VIGRANUMPY_INSTALL_DIR}" )
  IF(PYTHON_SPHINX)
    MESSAGE( STATUS "  vigranumpy manuals will be installed at: "
      "${CMAKE_INSTALL_PREFIX}/${DOCINSTALL}/vigranumpy/html/index.html")
  ELSE(PYTHON_SPHINX)
    MESSAGE( STATUS "  vigranumpy manuals cannot be generated "
      "(Sphinx missing)")
  ENDIF(PYTHON_SPHINX)
ELSE()
  MESSAGE( STATUS "  vigranumpy will NOT be installed" )
ENDIF()

IF(NOT TIFF_FOUND OR NOT JPEG_FOUND OR NOT PNG_FOUND OR NOT FFTW3_FOUND OR
   NOT HDF5_FOUND OR NOT VIGRANUMPY_DEPENDENCIES_FOUND)
  MESSAGE( STATUS "" )
  MESSAGE( STATUS "Consider setting DEPENDENCY_SEARCH_PREFIX to find missing libraries" )
ENDIF()

MESSAGE( STATUS "---------------------------------------------------------" )

=== test/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_SOURCE_DIR}/include)

INCLUDE(VigraAddTest)

ADD_SUBDIRECTORY(error)
ADD_SUBDIRECTORY(impex)
ADD_SUBDIRECTORY(utilities)
ADD_SUBDIRECTORY(pixeltypes)
ADD_SUBDIRECTORY(colorspaces)
ADD_SUBDIRECTORY(classifier)
ADD_SUBDIRECTORY(imgproc)
ADD_SUBDIRECTORY(functorexpression)
ADD_SUBDIRECTORY(convolution)
ADD_SUBDIRECTORY(morphology)
ADD_SUBDIRECTORY(fourier)
ADD_SUBDIRECTORY(math)
ADD_SUBDIRECTORY(optimization)
ADD_SUBDIRECTORY(tensorimaging)
ADD_SUBDIRECTORY(simpleanalysis)
ADD_SUBDIRECTORY(image)
ADD_SUBDIRECTORY(multiarray)
ADD_SUBDIRECTORY(multiconvolution)
ADD_SUBDIRECTORY(voxelneighborhood)
ADD_SUBDIRECTORY(volumelabeling)
ADD_SUBDIRECTORY(watersheds3d)
ADD_SUBDIRECTORY(multidistance)
ADD_SUBDIRECTORY(multimorphology)
ADD_SUBDIRECTORY(seededRegionGrowing3d)
ADD_SUBDIRECTORY(sampler)
ADD_SUBDIRECTORY(hdf5impex)
ADD_SUBDIRECTORY(sifImport)

=== src/impex/CMakeLists.txt ===
IF(JPEG_FOUND)
  ADD_DEFINITIONS(-DHasJPEG)
  INCLUDE_DIRECTORIES(${JPEG_INCLUDE_DIR})
ENDIF(JPEG_FOUND)

IF(PNG_FOUND)
  ADD_DEFINITIONS(-DHasPNG)
  INCLUDE_DIRECTORIES(${PNG_INCLUDE_DIR})
ENDIF(PNG_FOUND)

IF(TIFF_FOUND)
  ADD_DEFINITIONS(-DHasTIFF)
  INCLUDE_DIRECTORIES(${TIFF_INCLUDE_DIR})
ENDIF(TIFF_FOUND)

IF(HDF5_FOUND)
  ADD_DEFINITIONS(-DHasHDF5 ${HDF5_CPPFLAGS})
  INCLUDE_DIRECTORIES(${HDF5_INCLUDE_DIR})
ENDIF(HDF5_FOUND)

IF (MSVC OR MINGW)
  ADD_DEFINITIONS(-DVIGRA_DLL)
ENDIF ()

ADD_LIBRARY(vigraimpex SHARED
    bmp.cxx
    byteorder.cxx
    codecmanager.cxx
    gif.cxx
    hdr.cxx
    hdf5impex.cxx
    hdf5_rf_impex.cxx
    iccjpeg.c
    imageinfo.cxx
    jpeg.cxx
    png.cxx
    pnm.cxx
    rgbe.c
    sifImport.cxx
    sun.cxx
    tiff.cxx
    viff.cxx
    void_vector.cxx)

STRING(REGEX REPLACE "\\." "" LIBRARY_VERSION_STRING ${vigra_version})
SET_TARGET_PROPERTIES(vigraimpex PROPERTIES VERSION 3.${LIBRARY_VERSION_STRING} SOVERSION 3)

IF(JPEG_FOUND)
  TARGET_LINK_LIBRARIES(vigraimpex ${JPEG_LIBRARIES})
ENDIF(JPEG_FOUND)

IF(PNG_FOUND)
  TARGET_LINK_LIBRARIES(vigraimpex ${PNG_LIBRARIES})
ENDIF(PNG_FOUND)

IF(TIFF_FOUND)
  TARGET_LINK_LIBRARIES(vigraimpex ${TIFF_LIBRARIES})
ENDIF(TIFF_FOUND)

IF(HDF5_FOUND)
  TARGET_LINK_LIBRARIES(vigraimpex ${HDF5_LIBRARIES})
ENDIF(HDF5_FOUND)

INSTALL(TARGETS vigraimpex
        EXPORT vigra-targets
        RUNTIME DESTINATION bin 
        LIBRARY DESTINATION lib${LIBDIR_SUFFIX} 
        ARCHIVE DESTINATION lib${LIBDIR_SUFFIX})

=== test/classifier/CMakeLists.txt ===
if(HDF5_FOUND)
    INCLUDE_DIRECTORIES(${HDF5_INCLUDE_DIR})
  
    ADD_DEFINITIONS(${HDF5_CPPFLAGS} -DHasHDF5)
	VIGRA_ADD_TEST(test_classifier test.cxx LIBRARIES vigraimpex ${HDF5_LIBRARIES})
else()
    MESSAGE(STATUS "** WARNING: test_classifier::RFHDF5Test() will not be executed")
	VIGRA_ADD_TEST(test_classifier test.cxx )
endif()

VIGRA_ADD_TEST(classifier_speed_comparison speed_comparison.cxx)

add_subdirectory(data)

=== test/multiconvolution/CMakeLists.txt ===
VIGRA_ADD_TEST(test_multiconvolution test.cxx)

VIGRA_ADD_TEST(test_multiconvolution_speed speedtest.cxx)

=== test/sifImport/CMakeLists.txt ===
VIGRA_ADD_TEST(test_sifImport test.cxx LIBRARIES vigraimpex)
VIGRA_COPY_TEST_DATA(testSif_4_16_30001.sif testSif_4_13_30000.sif)

=== vigranumpy/docsrc/CMakeLists.txt ===
IF(PYTHON_SPHINX)
	# vigranumpy documentation generation using sphinx
	IF(DEFINED VIGRANUMPY_DOCDIR)
		MESSAGE(SEND_ERROR "VIGRANUMPY_DOCDIR already defined! Please delete from Cache.")
	ENDIF()
	SET(VIGRANUMPY_DOCDIR ${DOCDIR}/vigranumpy)
	SET(SPHINX_OPTS ${SPHINX_OPTS} CACHE STRING
		"options passed to sphinx during vigranumpy doc generation"
		FORCE)
	IF(NOT DEFINED SPHINX_PAPER)
		SET(SPHINX_PAPER a4)
	ENDIF()
	SET(SPHINX_PAPER ${SPHINX_PAPER} CACHE STRING
		"Papersize for sphinx documentation generation (a4, letter)"
		FORCE)
	SET(SPHINX_ALLOPTS
		-d ${VIGRANUMPY_DOCDIR}/doctrees
		-D latex_paper_size=${SPHINX_PAPER}
		-c ${CMAKE_CURRENT_BINARY_DIR}
		${SPHINX_OPTS})
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/_static)
	CONFIGURE_FILE(
		${CMAKE_CURRENT_SOURCE_DIR}/conf.py.in
		${CMAKE_CURRENT_BINARY_DIR}/conf.py
		@ONLY)
    
	ADD_CUSTOM_TARGET (doc_python
		COMMAND ${CMAKE_COMMAND} -E make_directory
			${VIGRANUMPY_DOCDIR}
		COMMAND ${PYTHON_SPHINX} -b html
			${SPHINX_ALLOPTS}
			${CMAKE_CURRENT_SOURCE_DIR}
			${VIGRANUMPY_DOCDIR}
		COMMENT "Generating vigranumpy documentation")

ELSE(PYTHON_SPHINX)
	# no vigranumpy documentation if sphinx not available
	ADD_CUSTOM_TARGET (doc_python 
		${CMAKE_COMMAND} -E echo
		"Cannot generate Python documentation for vigranumpy. "
		"(sphinx-build not found)"
        VERBATIM)

ENDIF(PYTHON_SPHINX)

ADD_DEPENDENCIES(doc_python vigranumpy)
ADD_DEPENDENCIES(doc_python doc_cpp)
ADD_DEPENDENCIES(doc doc_python)

=== vigranumpy/src/CMakeLists.txt ===
ADD_SUBDIRECTORY(core)

IF(FFTW3_FOUND)
    ADD_SUBDIRECTORY(fourier)
ELSE()
    MESSAGE(STATUS "vigranumpy fourier module will not be built (fftw3 missing)")
ENDIF(FFTW3_FOUND)

=== vigranumpy/test/CMakeLists.txt ===
INCLUDE_DIRECTORIES(${VIGRANUMPY_INCLUDE_DIRS})

SET(TEST_SCRIPTS
    test_arraytypes.py
    test_impex.py
    test1.py
    test2.py
    test3.py)

# setup the file 'testsuccess.cxx' which will become out-of-date when the
# last test failed or when the tests code changed, so that tests are re-executed
SET(TEST_SUCCESS_FILE "${CMAKE_CURRENT_BINARY_DIR}/testsuccess.cxx")

# find the vigranumpy modules that we want to test, and make
# 'testsuccess.cxx' depend on them
# TODO: Does cmake provide a standard way to find those dependencies? 
GET_TARGET_PROPERTY(VIGRANUMPY_DEPENDS vigranumpy VIGRA_DEPENDS)
SEPARATE_ARGUMENTS(VIGRANUMPY_DEPENDS)

add_custom_command(
    OUTPUT ${TEST_SUCCESS_FILE}
    DEPENDS ${TEST_SCRIPTS} ${VIGRANUMPY_DEPENDS}
    COMMAND ${CMAKE_COMMAND}
    ARGS -E touch ${TEST_SUCCESS_FILE})

FILE(GLOB TESTSUCCESS_FOUND ${TEST_SUCCESS_FILE})
IF(NOT TESTSUCCESS_FOUND)
    FILE(WRITE ${TEST_SUCCESS_FILE}
     "// auto-generated dummy file to force re-execution of failed tests
")
ENDIF()

# setup the test target

IF(AUTOBUILD_TESTS)
  ADD_LIBRARY(vigranumpytest SHARED 
               vigranumpytest.cxx ${TEST_SUCCESS_FILE} ${TEST_SCRIPTS})
ELSE()
  ADD_LIBRARY(vigranumpytest SHARED EXCLUDE_FROM_ALL
               vigranumpytest.cxx ${TEST_SUCCESS_FILE} ${TEST_SCRIPTS})
ENDIF()

IF(PYTHON_PLATFORM MATCHES "^windows$")
    SET_TARGET_PROPERTIES(vigranumpytest PROPERTIES PREFIX "" SUFFIX  ".pyd")
ELSEIF(MACOSX)
    SET_TARGET_PROPERTIES(vigranumpytest PROPERTIES PREFIX "" SUFFIX ".so")
ELSE()
    SET_TARGET_PROPERTIES(vigranumpytest PROPERTIES PREFIX "")
ENDIF()

TARGET_LINK_LIBRARIES(vigranumpytest ${VIGRANUMPY_LIBRARIES} vigranumpy_core)
ADD_DEPENDENCIES(check_python vigranumpytest)
ADD_DEPENDENCIES(ctest vigranumpytest)
ADD_DEPENDENCIES(vigranumpytest vigranumpy)

# setup the file 'set_path.py' to ensure that tests are run against the binaries
# which are currently being built, not against (possibly outdated) installed modules
MACRO(DEPENDENCY_PATH variable target)
    GET_TARGET_PROPERTY(${variable} ${target} LOCATION)
    STRING(REGEX REPLACE "(/\\$\\([^\\)]*\\)/[^/]*|/[^/]*)$" "" ${variable} ${${variable}}) # get path prefix
    FILE(TO_NATIVE_PATH ${${variable}} ${variable})
ENDMACRO(DEPENDENCY_PATH)

DEPENDENCY_PATH(VIGRAIMPEX_PATH vigraimpex)
DEPENDENCY_PATH(VIGRANUMPYTEST_PATH vigranumpytest)

STRING(REGEX REPLACE "/vigra$" "" VIGRANUMPY_TMP_PATH ${vigranumpy_tmp_dir})
FILE(TO_NATIVE_PATH "${VIGRANUMPY_TMP_PATH}" VIGRANUMPY_TMP_PATH)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/set_paths.py.in
                ${CMAKE_CURRENT_BINARY_DIR}/set_paths.py 
                @ONLY)


IF(NOT PYTHON_NOSETESTS_NOT_FOUND)
    # copy the individual test scripts
    FOREACH(test_script ${TEST_SCRIPTS})
        ADD_CUSTOM_COMMAND(
            TARGET vigranumpytest
            POST_BUILD
            COMMAND ${CMAKE_COMMAND}
            ARGS -E copy_if_different
            ${CMAKE_CURRENT_SOURCE_DIR}/${test_script} ${CMAKE_CURRENT_BINARY_DIR}/${test_script}
            COMMENT "Running vigranumpy tests")
    ENDFOREACH(test_script)

    VIGRA_NATIVE_PATH(PYTHON_EXECUTABLE ${PYTHON_EXECUTABLE})
    
    # Windows: Set the DLL path to the binaries currently being built
    #          (so that binaries which are already installed are ignored)
    #          This is not necessary on Linux, because the correct path
    #          is hard-coded into the module by means of 'rpath'
    set(VIGRA_PATH "")
    if(WIN32)
        IF(CYGWIN)
            SET(PATHSEP ":")
        ELSE()
            SET(PATHSEP ";")
        ENDIF()
        FOREACH(lib ${LIBRARIES})
            GET_TARGET_PROPERTY(p ${lib} LOCATION)
            if(p)
                GET_FILENAME_COMPONENT(p ${p} PATH)
                VIGRA_NATIVE_PATH(p ${p})
                SET(VIGRA_PATH  "${p}${PATHSEP}${VIGRA_PATH}")
           endif()
        ENDFOREACH(lib)
    endif()
    
    # Setup the test execution script
    VIGRA_NATIVE_PATH(VIGRA_CURRENT_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})
    SET(VIGRA_TEST_EXECUTABLE "${PYTHON_EXECUTABLE} -c \"import nose; nose.main()\" .")        
    IF(MSVC OR MINGW)
        SET(VIGRA_TEST_EXECUTABLE "${VIGRA_TEST_EXECUTABLE} %CONFIGURATION%")
        SET(VIGRA_RUN_TEST "${CMAKE_CURRENT_BINARY_DIR}/run_vigranumpytest.bat")
        CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/config/run_test.bat.in
                        ${VIGRA_RUN_TEST}
                        @ONLY)
    ELSE()            
        SET(VIGRA_RUN_TEST "${CMAKE_CURRENT_BINARY_DIR}/run_vigranumpytest.sh")
        CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/config/run_test.sh.in
                        ${VIGRA_RUN_TEST}
                       @ONLY)
        EXECUTE_PROCESS(COMMAND chmod u+x ${VIGRA_RUN_TEST} OUTPUT_QUIET ERROR_QUIET)
    ENDIF()

    # register the test execution command
    # VIGRA_CONFIGURATION is 'release' or 'debug' on Windows, nothing on Linux
    # variable CMAKE_CFG_INTDIR contains a dot '.' for a Windows nmake build, or
    #                           '$(OutDir)' for a VisualStudio build (OutDir will be
    #                           set by VS at build time)
    IF(NOT CMAKE_CFG_INTDIR STREQUAL ".")
        SET(VIGRA_CONFIGURATION ${CMAKE_CFG_INTDIR})
    ELSE()
        SET(VIGRA_CONFIGURATION)
    ENDIF()

    IF(AUTOEXEC_TESTS)
        add_custom_command(
            TARGET vigranumpytest
            POST_BUILD
            COMMAND ${VIGRA_RUN_TEST} ARGS ${VIGRA_CONFIGURATION}
            COMMENT "Running vigranumpy tests")
    ENDIF()

    ADD_TEST(vigranumpytest ${VIGRA_RUN_TEST} ${VIGRA_CONFIGURATION})

ELSE()
        MESSAGE(STATUS "  vigranumpy tests will NOT be executed (nosetests missing)")
ENDIF()

=== vigranumpy/src/core/CMakeLists.txt ===

# note special treatment of target vigranumpy_core: 
# module name is automatically changed into vigranumpycore
VIGRA_ADD_NUMPY_MODULE(core 
  SOURCES 
    vigranumpycore.cxx
    converters.cxx
  VIGRANUMPY)

VIGRA_ADD_NUMPY_MODULE(impex 
  SOURCES
    impex.cxx
  LIBRARIES   
    ${VIGRANUMPY_IMPEX_LIBRARIES}
  VIGRANUMPY)   
     
VIGRA_ADD_NUMPY_MODULE(sampling 
  SOURCES
    sampling.cxx
  VIGRANUMPY)
   
VIGRA_ADD_NUMPY_MODULE(filters SOURCES
    kernel.cxx
    convolution.cxx
    filters.cxx
    tensors.cxx
    morphology.cxx
  VIGRANUMPY)
   
VIGRA_ADD_NUMPY_MODULE(analysis SOURCES
    segmentation.cxx
    edgedetection.cxx
    interestpoints.cxx
  VIGRANUMPY)
   
VIGRA_ADD_NUMPY_MODULE(learning SOURCES
    random_forest_old.cxx
    random_forest.cxx
  LIBRARIES   
    ${VIGRANUMPY_IMPEX_LIBRARIES}
  VIGRANUMPY)
   
VIGRA_ADD_NUMPY_MODULE(colors SOURCES
    colors.cxx
  VIGRANUMPY)
   
VIGRA_ADD_NUMPY_MODULE(noise SOURCES
    noise.cxx
  VIGRANUMPY)
   
VIGRA_ADD_NUMPY_MODULE(geometry SOURCES
    geometry.cxx
  VIGRANUMPY)

=== debian/changelog ===
libvigraimpex (1.7.1+dfsg1-3) unstable; urgency=low

  * QA upload
  * Fix build failure with GCC 4.7. Closes: #667258.
  * Build-depend on libpng-dev. Closes: #662414.

 -- Matthias Klose <doko@debian.org>  Mon, 16 Apr 2012 23:06:00 +0200

libvigraimpex (1.7.1+dfsg1-2) unstable; urgency=low

  * QA upload
  * Patch libpng15: Fix FTBFS with libpng 1.5 (closes: #636003). Thanks to
    Nobuhiro Iwamatsu and Joachim Schleicher for forwarding and testing
    the patch.
  * Replace build-dependency on libpng12-dev by libpng-dev | libpng12-dev
    in order to ease the upcoming libpng transition.
  * Fix FTBFS on sh4 architecture by using -mieee flag (closes: #633818).
    Thanks to Nobuhiro Iwamatsu for the patch!

 -- Ralf Treinen <treinen@debian.org>  Thu, 04 Aug 2011 13:57:08 +0200

libvigraimpex (1.7.1+dfsg1-1) unstable; urgency=low

  * QA upload.
  * Set maintainer to Debian QA Group.
  * Demote Recommends of the documentation packages to Suggests.
  * Drop fix-tinyvectortest.diff, no longer needed.
  * Drop Vcs-* fields.
  * Strip jQuery code from .orig.tar.gz, as we don't have source for it.
    + Update debian/get-orig-source.sh, debian/rules, debian/watch.
    + Update debian/copyright.
  * Overhaul debian/rules. Stop using dh.
  * Use dh_sphinxdoc:
    + Update debian/control to use ${sphinxdoc:Depends} instead of hardcoded
      libjs-jquery.
    + Call it in debian/rules if it's installed. Otherwise, generate substvars
      manually.
  * Add missing build-dependency on python-support.

 -- Jakub Wilk <jwilk@debian.org>  Tue, 12 Jul 2011 19:34:24 +0200

libvigraimpex (1.7.1+dfsg-8) unstable; urgency=low

  * Unbreak fix-tinyvectortest.diff.

 -- Jakub Wilk <jwilk@debian.org>  Wed, 25 May 2011 01:21:31 +0200

libvigraimpex (1.7.1+dfsg-7) unstable; urgency=low

  * To fix FTBFS on s390, rewrite a loop in TinyVectorTest::equalIter(), so
    that it doesn't trigger bug in GCC 4.6 (see Debian bug #627795).
    [fix-tinyvectortest.diff]

 -- Jakub Wilk <jwilk@debian.org>  Tue, 24 May 2011 22:09:12 +0200

libvigraimpex (1.7.1+dfsg-6) unstable; urgency=low

  * To fix FTBFS on powerpc with GCC 4.6, use epsilon comparison in
    ConvolutionTest::recursiveFilterTestFromRepeatWithAvoid. Thanks to Stefano
    Rivera for debugging and for the patch. [fix-convolutiontest.diff]
  * Allow libvigraimpex-dev to be co-installable with over providers of
    libhdf5-dev than libhdf5-serial-dev (closes: #627421). Thanks to Laurent
    Bonnaud for the bug report.

 -- Jakub Wilk <jwilk@debian.org>  Fri, 20 May 2011 20:24:30 +0200

libvigraimpex (1.7.1+dfsg-5) unstable; urgency=low

  * Use default Python version when building documentation.
  * Update docsrc-doxygen-1.7.diff to deal with the latest Doxygen.
  * Remove unused jquery.js from libvigraimpex-doc.
  * Add a missing include to fix FTBFS with GCC 4.6 (closes: #625104). Thanks
    to Lucas Nussbaum for the bug report. [fix-ftbfs-gcc4.6.diff]
  * Bump standards version to 3.9.2 (no changes needed).
  * Mark more symbols as optional.

 -- Jakub Wilk <jwilk@debian.org>  Mon, 02 May 2011 19:47:58 +0200

libvigraimpex (1.7.1+dfsg-4) unstable; urgency=low

  * Preserve symlinks when copying object files from one build directory to
    another (closes: #618667).

 -- Jakub Wilk <jwilk@debian.org>  Sun, 20 Mar 2011 15:50:05 +0100

libvigraimpex (1.7.1+dfsg-3) unstable; urgency=low

  * Update the symbols file.
  * On buildds, artificially limit paralellism in order not to run out of RAM.

 -- Jakub Wilk <jwilk@debian.org>  Tue, 15 Mar 2011 15:14:04 +0100

libvigraimpex (1.7.1+dfsg-2) unstable; urgency=low

  * Upload to unstable.
  * Fix patch headers to be in line with DEP-3.
  * Update the symbols file.

 -- Jakub Wilk <jwilk@debian.org>  Sat, 12 Mar 2011 20:29:34 +0100

libvigraimpex (1.7.1+dfsg-1) experimental; urgency=low

  * New upstream release.
    + Drop numpy-double-longdouble.diff, applied upstream.
    + Drop noise-normalization-invariant.diff, applied upstream.
    + Update debian/copyright.
    + Rename libvigraimpex2 to libvigraimpex3, following SONAME bump.
    + Update the symbols file.
    + Include the vigra-config script.
      + Patch it to return correct documentation path.
        [vigra-config-docdir.diff]
      + Update debian/NEWS.
      + Provide a new manual page.
  * Update patch headers.
  * Export LDFLAGS.
  * Remove Win32-only files and pre-built documentation from the .orig
    tarball to save some space.
  * Respect DEB_BUILD_OPTIONS=parallel=N.
  * Respect DEB_BUILD_OPTIONS=noopt.
  * Rename some private variables in debian/rules to make them lowercase.
  * Require that Numpy is usable with every supported Python version.
  * Avoid using SONAMEs in Python extension modules.
  * Convert debian/copyright to the latest DEP-5 version.
  * Install symlinks from /usr/share/doc/libvigraimpex-dev/html to
    /usr/share/doc/libvigraimpex-doc/html.
  * Install symlinks from /usr/share/doc/python-vigra/{html,rst} to
    /usr/share/doc/python-vigra-doc/{html,rst}.
  * Build Python extensions with -fno-strict-aliasing.
  * Remove ‘debian/tmp’ prefix from debian/*.install files.
  * Provide ‘build-arch’ and ‘build-indep’ targets in debian/rules.
  * Use an alternative dependency template in the symbols file to make sure
    that a strict versioned dependency on the shared library will be generated
    for packages using optional (private) symbols.

 -- Jakub Wilk <jwilk@debian.org>  Sun, 20 Feb 2011 23:21:40 +0100

=== debian/control ===
Source: libvigraimpex
Section: libs
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: dpkg-dev (>= 1.15.3~), debhelper (>= 7.0.50~),
  cmake,
  libfftw3-dev, libpng-dev, libjpeg-dev, libtiff4-dev,
  libhdf5-serial-dev (>= 1.8),
  python-all-dev, python-numpy, libboost-python-dev, python-nose
Build-Depends-Indep:
  python, python-support, python-sphinx, doxygen, texlive-latex-base, ghostscript
Build-Conflicts: autoconf2.13
XS-Python-Version: >= 2.5
Standards-Version: 3.9.2
Homepage: http://hci.iwr.uni-heidelberg.de/vigra/

Package: libvigraimpex-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${python:Depends},
  libvigraimpex3 (= ${binary:Version}),
  libfftw3-dev, libpng12-dev, libjpeg-dev, libtiff4-dev, libhdf5-serial-dev (>= 1.8) | libhdf5-dev
Suggests: libvigraimpex-doc
Description: development files for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment. 
 . 
 This package contains the header and development files needed to
 build programs and packages using VIGRA.

Package: libvigraimpex3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library 
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment. 

Package: libvigraimpex-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Suggests: libvigraimpex-dev, python-vigra-doc
Description: Documentation for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment. 
 . 
 This package contains documentation for the VIGRA library.

Package: python-vigra
Section: python
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}
Recommends: python-h5py, python-qt4
Suggests: python-vigra-doc
Description: Python bindings for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment.
 .
 This package exports the functionality of the VIGRA library to Python.

Package: python-vigra-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Suggests: python-vigra, libvigraimpex-doc
Description: Documentation for Python bindings for the C++ computer vision library
 Vision with Generic Algorithms (VIGRA) is a computer vision library
 that puts its main emphasis on flexible algorithms, because
 algorithms represent the principle know-how of this field. The
 library was consequently built using generic programming as
 introduced by Stepanov and Musser and exemplified in the C++ Standard
 Template Library. By writing a few adapters (image iterators and
 accessors) you can use VIGRA's algorithms on top of your data
 structures, within your environment.
 .
 This package contains documentation for Python bindings for the VIGRA library.

=== debian/rules ===
#!/usr/bin/make -f

CFLAGS := $(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS)
LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS) -Wl,--as-needed

# These don't need to be exported and if they are we'll get the flags
# duplicated in the command line.
unexport CFLAGS
unexport CXXFLAGS
unexport LDFLAGS

# sh4 needs -mieee option of gcc and g++
ifeq ($(DEB_HOST_ARCH),sh4)
CFLAGS += -mieee
CXXFLAGS += -mieee
endif

space = $() $()
here = $(dir $(firstword $(MAKEFILE_LIST)))/..
current_version = $(shell cd $(here) && dpkg-parsechangelog | sed -n -r -e "/Version: (.*)/ { s//\1/p; q; }")
upstream_version = $(firstword $(subst -,$(space),$(current_version)))

cmake_options = \
    -DCMAKE_INSTALL_PREFIX=/usr \
    -DCMAKE_VERBOSE_MAKEFILE=ON \
    -DCMAKE_C_FLAGS_RELEASE="$(CFLAGS)" \
    -DCMAKE_CXX_FLAGS_RELEASE="$(CXXFLAGS)" \
    -DCMAKE_SHARED_LINKER_FLAGS_RELEASE="$(LDFLAGS)"
cmake_python_options = \
    -DPYTHON_EXECUTABLE=/usr/bin/python$(1) \
    -DPYTHON_INCLUDE_DIR=/usr/include/python$(1)/ \
    -DPYTHON_LIBRARY=/usr/lib/libpython$(1).so \
    -DBoost_PYTHON_LIBRARY_RELEASE=/usr/lib/libboost_python-py$$(echo $(1) | tr -d .).so

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	njobs_requested := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
ifeq ($(wildcard /build/buildd-*/),)
	njobs := $(njobs_requested)
else
	# On buildds, artificially limit paralellism in order not to run out of RAM.
	mem_total := $(shell grep MemTotal /proc/meminfo | tr -s ' ' | cut -d' ' -f2)
	njobs_max := $(patsubst 0,1,$(shell echo $$(( $(mem_total) / 500000 ))))
	njobs := $(shell echo $$(( $(njobs_requested) > $(njobs_max) ? $(njobs_max) : $(njobs_requested) )))
endif
	parallel := -j$(or $(njobs),1)
endif

# build and build-* targets
# =========================

.PHONY: build build-arch build-indep

build: build-arch build-indep

build-indep:
	# Nothing to do in build-indep, "thanks" to bug #374029.

build-arch:
	dh_testdir
	$(info INFO: number of parallel processes:)
	$(info - requested: $(or $(njobs_requested),none))
	$(info - maximum: $(or $(njobs_max),none))
	$(info - actual: $(or $(njobs),1))
	$(MAKE) -f debian/rules \
		obj/CMakeCache.txt \
		$(patsubst %,obj.%/CMakeCache.txt,$(shell pyversions -r))
	$(MAKE) -f debian/rules \
		doc/changelog \
		obj/build-stamp \
		$(patsubst %,obj.%/build-stamp,$(shell pyversions -r))
ifeq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	$(MAKE) -f debian/rules \
		obj/test-stamp \
		$(patsubst %,obj.%/test-stamp,$(shell pyversions -r))
endif

obj/CMakeCache.txt:
	mkdir -p $(dir $(@))
	cd $(dir $(@)) && cmake .. $(cmake_options) \
		-DPYTHON_EXECUTABLE=/usr/bin/python \
		-DWITH_VIGRANUMPY=0

obj.python%/CMakeCache.txt:
	mkdir -p $(dir $(@))
	cd $(dir $(@)) && \
		CXXFLAGS=-fno-strict-aliasing cmake .. $(cmake_options) $(call cmake_python_options,$(*))
	if ! grep VIGRANUMPY_DEPENDENCIES $(@) > /dev/null; then \
		echo "Error: Numpy for Python $* not found" >&2; \
		rm -f $(@); \
		exit 1; \
	fi
	# We don't want to link with libpythonX.Y.
	# We don't want SONAMES (except vigranumpycore.so)
	find $(dir $(@))/vigranumpy/ -name 'link.txt' -exec sed -i \
		-e 's/ -lpython[0-9.]\+ / /g' \
		-e '/-Wl,-soname,vigranumpycore/b' \
		-e 's/ -Wl,-soname,[^ ]\+ / /' \
		{} +

obj/build-stamp: obj/CMakeCache.txt
	$(MAKE) $(parallel) -C $(dir $(@))
	chmod a-x vigranumpy/test/*.py # nosetest would skip executable *.py
	touch $(@)

obj.python%/build-stamp: obj.python%/CMakeCache.txt obj/build-stamp
	cd obj && find . -name '*.o' -o -name '*.so' -o -name '*.so.*' | xargs cp -v --preserve=links --parents -t ../$(dir $(@))
	$(MAKE) $(parallel) -C $(dir $(@))
	touch $(@)

obj/test-stamp: obj/build-stamp
	$(MAKE) check -C $(dir $(@))
	touch $(@)

obj.python%/test-stamp:: obj.python%/build-stamp
	$(MAKE) vigranumpytest -C $(dir $(@))
	touch $(@)

doc/changelog: docsrc/credits_changelog.dxx
	sh debian/convert-changelog.sh < $(<) > $(@)

# binary and binary-* targets
# ===========================

.PHONY: binary binary-arch binary-indep

binary: binary-arch binary-indep

binary-arch: build-arch
	dh_testdir
	dh_testroot
	$(MAKE) -f debian/rules \
		obj/install-stamp \
		$(patsubst %,obj.%/install-stamp,$(shell pyversions -r))
	dh_install -a
	dh_installdocs -a
	dh_installchangelogs -a doc/changelog
	dh_installexamples -a
	find -path './debian/*/usr/share/doc/*/examples/*' -exec chmod a-x '{}' +
	dh_installman -a
	dh_pysupport -a
	dh_link -a
	dh_compress -a
	dh_fixperms -a
	dh_strip -a
	dh_makeshlibs
	sed -i -e 's/= PRIVATE/= $(current_version)/' debian/*/DEBIAN/symbols
	dh_shlibdeps
	# See <http://lists.debian.org/debian-python/2010/07/msg00042.html>:
	$(or $(wildcard /usr/bin/dh_numpy),debian/dh_numpy) -p python-vigra
	dh_installdeb -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

.PHONY: binary-indep
binary-indep: build-indep
	dh_testdir
	dh_testroot
	$(MAKE) -f debian/rules \
		doc/vigra/build-stamp \
		doc/vigranumpy/build-stamp
	dh_installdocs -i -XLICENSE.txt -Xobjects.inv -Xdoctrees -X.buildinfo -Xbuild-stamp
	cd debian/libvigraimpex-doc/usr/share/doc/libvigraimpex-doc/ && \
		rm -rf html && \
		mv vigra html && \
		rm -f html/jquery.js && \
		sed -r -i \
			-e 's!(<a href=")LICENSE.txt(">)!\1/usr/share/doc/libvigraimpex-doc/copyright\2!g' \
			html/index.html
	cd debian/python-vigra-doc/usr/share/doc/python-vigra-doc/ && \
		rm -rf html && \
		mv vigranumpy html
	dh_installchangelogs -i
	dh_link -i
ifeq "$(wildcard /usr/bin/dh_sphinxdoc)" ""
	echo "sphinxdoc:Depends=libjs-jquery" >> debian/python-vigra-doc.substvars
else
	dh_sphinxdoc -p python-vigra-doc /usr/share/doc/python-vigra-doc/html/
endif
	dh_compress -i -X.js -X_sources
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

%/install-stamp: %/build-stamp
	$(MAKE) -C $(dir $(@)) install DESTDIR=$(CURDIR)/debian/tmp/
	touch $(@)

doc/vigra/build-stamp: obj/build-stamp
	$(MAKE) doc_cpp -C obj/
	touch $(@)

doc/vigranumpy/build-stamp: obj.$(shell pyversions -d)/build-stamp doc/vigra/build-stamp
	ln -sf $(CURDIR)/vigranumpy/docsrc/c_api_replaces.txt obj.$(shell pyversions -d)/vigranumpy/docsrc/
	$(MAKE) doc_python -C obj.$(shell pyversions -d)/
	touch $(@)

# clean target
# ============

.PHONY: clean
clean:
	dh_testdir
	dh_clean
	rm -rf obj*/
	find doc/ -type f -delete

# get-orig-source target
# ======================

.PHONY: get-orig-source
get-orig-source:
	sh $(here)/debian/get-orig-source.sh $(upstream_version)

.NOTPARALLEL:

# vim:ts=4 sw=4 noet
